//+------------------------------------------------------------------+
//|                                    Sidus v.3 Entry Indicator.mq4 |
//|                                                                  |
//|                                                   Ideas by Sidus |
//+------------------------------------------------------------------+
#property copyright ""
#property link      ""

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 Yellow
#property indicator_color2 Red
#property indicator_color3 Aqua
#property indicator_color4 Yellow
#property indicator_width1 2
#property indicator_width2 2
#property indicator_width3 3  
#property indicator_width4 3   

//
//
//
//
//
extern string    N_FastPeriod   = "Fast MA Period" ;
extern int       Fast_MA        = 5;
extern string    N_FastMode     = "0=SMA,1=EMA,2=SSMA,3=LWMA";
extern int       Fast_Mode      = 1;
extern string    N1_FastPrice   = "0=Close,1=Open,2=High,3=Low";
extern string    N2_FastPrice   = "4=Median,5=Typical,6=Weighted";
extern int       Fast_Price     = 0;
//
//
extern string    N_SlowPeriod   = "Slow MA Period";
extern int       Slow_MA        = 10;
extern string    N_SlowMode     = "0=SMA,1=EMA,2=SSMA,3=LWMA";
extern int       Slow_Mode      = 1;
extern string    N1_SlowPrice   = "0=Close,1=Open,2=High,3=Low";
extern string    N2_SlowPrice   = "4=Median,5=Typical,6=Weighted";
extern int       Slow_Price     = 0;
//
extern string    N_RSIPeriod    = "RSI Period";
extern int       RSIPeriod      = 20;
//
extern string    AlertTrueFalse = "Alert Yes or NO";
extern bool      Alerts         = true;

double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];
double trend[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int init()
{
   IndicatorBuffers(5);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexBuffer(2,ExtMapBuffer3); SetIndexStyle(2,DRAW_ARROW); SetIndexArrow(2,233);
   SetIndexBuffer(3,ExtMapBuffer4); SetIndexStyle(3,DRAW_ARROW); SetIndexArrow(3,234);
   SetIndexBuffer(4,trend);
   return(0);
}
int deinit() { return(0); }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+


int start()
{
   int counted_bars=IndicatorCounted();
   int limit;
   
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit=MathMin(Bars-counted_bars,Bars-1);
   
   for(int i=limit; i>=0; i--)
   {
      ExtMapBuffer1[i] = iMA(NULL,0,Fast_MA,0,Fast_Mode,Fast_Price,i);
      ExtMapBuffer2[i] = iMA(NULL,0,Slow_MA,0,Slow_Mode,Slow_Price,i);
      ExtMapBuffer3[i] = EMPTY_VALUE;
      ExtMapBuffer4[i] = EMPTY_VALUE;
      trend[i]         = trend[i+1];
     
      double dist = iATR(NULL,0,20,i);
      double rsi  = iRSI(NULL, 0, RSIPeriod, PRICE_CLOSE, i);
      double diff = (ExtMapBuffer1[i]-ExtMapBuffer2[i]);

         if (diff>0 && rsi>50) trend[i] =  1;
         if (diff<0 && rsi<50) trend[i] = -1;
         if (trend[i]!=trend[i+1])
            if (trend[i]==1)
              {
                  ExtMapBuffer3[i] = ExtMapBuffer1[i]-dist;
                  PlaySound("FxBootCamp.wav");
                  simpleAlert("TEB-FGB-SIDOS Entry point: buy at "+Ask+"!!");
               }   
            else 
               { 
                  ExtMapBuffer4[i] = ExtMapBuffer1[i]+dist;
                  PlaySound("FxBootCamp.wav");
                  simpleAlert("TEB-FGB-SIDOS Entry point: sell at "+Bid+"!!");
               }
   }
/*   
   if(Alerts)
      if (trend[0]!=trend[i+1])
      {
         if (trend[0]==1)
               simpleAlert("Entry point: buy at "+Ask+"!!");
         else  simpleAlert("Entry point: sell at "+Bid+"!!");
      }
*/      
   return(0);
}

void simpleAlert(string doWhat)
{
   static datetime previousTime;
   static string   previousMessage;
   
   if (previousTime != Time[0] || doWhat != previousMessage)
   {
      previousTime    = Time[0];
      previousMessage =  doWhat;
         PlaySound("FxBootCamp.wav");
         Alert(doWhat);
   }
}


